package com.zhilian.business.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.zhilian.business.domain.Markers;
import com.zhilian.business.domain.middle.MarkersFence;
import com.zhilian.business.service.MarkersFenceService;
import com.zhilian.business.service.MarkersService;
import com.zhilian.common.core.domain.Result;
import com.zhilian.common.core.web.controller.BaseController;
import com.zhilian.common.core.web.page.TableDataInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/markers")
public class MarkersController extends BaseController {
    @Autowired
    private MarkersService markersService;
    @Autowired
    private MarkersFenceService markersFenceService;

    /**
     * 车辆标识列表
     * @param markers
     * @return
     */
    @PostMapping("list")
    public Result<TableDataInfo<Markers>> list(@RequestBody Markers markers) {
        startPage();
        List<Markers> result = markersService.selectMarkersList(markers);
        return getDataTable(result);
    }

    @GetMapping("markersVehicle")
    public Result<List<Markers>> markersVehicle() {
        List<Markers> listMarkers = markersService.listMarkers();
        return Result.success(listMarkers);
    }

    @PostMapping("insert")
    public Result insert(@RequestBody Markers markers){
        return toAjax(markersService.save(markers));
    }

    @PostMapping("update")
    public Result update(@RequestBody Markers markers) {
        return toAjax(markersService.updateById(markers));
    }

    @PostMapping("delete/{markersId}")
    public Result delete(@PathVariable Long markersId) {
        markersFenceList(markersId).forEach(markersFence -> {
            markersFenceService.removeById(markersId);
        });
        return toAjax(markersService.removeById(markersId));
    }

    @PostMapping("insertMarkersFence")
    public Result insertMarkersFenceMarkers(@RequestBody MarkersFence markersFence){
        return toAjax(markersFenceService.save(markersFence));
    }

    @PostMapping("markersFenceList/{markersId}")
    public List<MarkersFence> markersFenceList(@PathVariable Long markersId){
        LambdaQueryWrapper<MarkersFence> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(MarkersFence::getMarkerId, markersId);
        return markersFenceService.list(queryWrapper);
    }

}
